rem @echo off

REM converting %APPROOT% first to it's short form

if "%~1"=="" (

	SET APPROOT=C:\PROGRA~1\IBM\edge

) else (
	if EXIST "%~1" (
		set APPROOT=%~s1
	) else (
		echo "Directory does not exist"
		exit 1
	)
)

set /a MAJORVERSION=8
set /a MINORVERSION=0
set /a REVISION=0
set /a PATCHLEVEL=9
set PATCH_BUILD="FALSE"

REM Changing PATCH_BUILD to false as IM uninstalls the base version of CP before installing the fix pack
if 0 GTR 0 set PATCH_BUILD="FALSE"
if 9 GTR 0 set PATCH_BUILD="FALSE"

rem Determine the windows version

FOR /F "tokens=*" %%A IN ('VER') DO SET WinVer=%%A
FOR %%A IN (%WinVer%) DO SET WinVer=%%A
SET WinVer=%WinVer:]=%
SET 4.=Windows NT 4
SET 5.00.=Windows 2000
SET 5.1.=Windows XP
SET 5.2.=Windows Server 2003
SET 6.0.6001=Windows Vista
SET 6.0.6002=Windows Server 2008
SET 6.1.=Windows 7 or Windows Server 2008 R2
FOR /L %%A IN (4,1,6) DO (
	FOR /F "tokens=1,2 delims==" %%B IN ('SET %%A.') DO (
		IF %WinVer% GEQ %%B (
			SET WinVerTxt=%%C
		)
	)
)

set cp_service="IBM Caching Proxy"

rem Locale settings

START /W REGEDIT /E %Temp%.\international.reg "HKEY_CURRENT_USER\Control Panel\International"
FOR /F "tokens=1* delims==" %%A IN ('TYPE %Temp%.\international.reg ^| FIND "Locale"') DO SET Locale=%%B
if /I "%WinVerTxt%"=="Windows 7 or Windows Server 2008 R2" (
	if %Locale% == "de-DE" (
		set lang=de_DE
	) else if %Locale% == "es-ES" (
		set lang=es_ES
	) else if %Locale% == "fr-FR" (
		set lang=fr_FR
	) else if %Locale% == "it-IT" (
		set lang=it_IT
	) else if %Locale% == "ko-KR" (
		set lang=ko_KR
	) else if %Locale% == "ja-JP" (
		set lang=ja_JP
	) else if %Locale% == "pl-PL" (
		set lang=pl_PL
	) else if %Locale% == "cs-CZ" (
		set lang=cs_CZ
	) else if %Locale% == "hu-HU" (
		set lang=hu_HU
	) else if %Locale% == "zh-TW" (
		set lang=zh_TW
	) else if %Locale% == "ru-RU" (
		set lang=ru_RU
	) else if %Locale% == "pt-BR" (
		set lang=pt_BR
	) else if %Locale% == "zh-CN" (
		set lang=zh_CN
	) else (
		set lang=en_US
	)
) else (
	SET Locale=%Locale:"=%
	set /a dec=0x%Locale%
	if "%dec%" == 1031 (
		set lang=de_DE
	) else if "%dec%" == 1034 (
		set lang=es_ES
	) else if "%dec%" == 1036 (
		set lang=fr_FR
	) else if "%dec%" == 1040 (
		set lang=it_IT
	) else if "%dec%" == 1042 (
		set lang=ko_KR
	) else if "%dec%" == 1041 (
		set lang=ja_JP
	) else if "%dec%" == 1045 (
		set lang=pl_PL
	) else if "%dec%" == 1029 (
		set lang=cs_CZ
	) else if "%dec%" == 1038 (
		set lang=hu_HU
	) else if "%dec%" == 1028 (
		set lang=zh_TW
	) else if "%dec%" == 1049 (
		set lang=ru_RU
	) else if "%dec%" == 1046 (
		set lang=pt_BR
	) else if "%dec%" == 2052 (
		set lang=zh_CN
	) else (
		set lang=en_US
	)
)

rem stopping cp service

if %PATCH_BUILD%=="TRUE" (

	sc query %cp_service% | find /I "STATE : 4"
	IF "%ERRORLEVEL%"=="0" net stop %cp_service%

rem backing up

	if not EXIST %APPROOT%\oldfiles mkdir %APPROOT%\oldfiles
	
	if EXIST %APPROOT%\cp\etc\%lang%\ibmproxy.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\ibmproxy.conf %APPROOT%\oldfiles
	if EXIST %APPROOT%\cp\etc\%lang%\rca.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\rca.conf %APPROOT%\oldfiles
	if EXIST %APPROOT%\cp\etc\%lang%\socks.conf.exp xcopy /Y/I %APPROOT%\cp\etc\%lang%\socks.conf.exp %APPROOT%\oldfiles
	if EXIST %APPROOT%\cp\etc\%lang%\pac.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\pac.conf %APPROOT%\oldfiles
	if EXIST %APPROOT%\cp\etc\%lang%\paccp.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\paccp.conf %APPROOT%\oldfiles
	if EXIST %APPROOT%\cp\etc\%lang%\pacpolicy.conf xcopy /Y/I %APPROOT%\cp\etc\%lang%\pacpolicy.conf %APPROOT%\oldfiles
	
	if NOT EXIST %APPROOT%\oldfiles\protect mkdir %APPROOT%\oldfiles\protect
	if EXIST %APPROOT%\cp\server_root\protect xcopy /Y/I/E/H %APPROOT%\cp\server_root\protect\* %APPROOT%\oldfiles\protect
)
